







 SUBROUTINE kpp_mechanism_driver(   &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


     USE module_configure
     USE module_state_description

     USE module_kpp_cb05_sorg_aq_interf 
     USE module_kpp_cb05_sorg_vbs_aq_interf 
     USE module_kpp_cbm4_interf 
     USE module_kpp_cbmz_bb_interf 
     USE module_kpp_cbmz_mosaic_interf 
     USE module_kpp_cri_mosaic_4bin_aq_interf 
     USE module_kpp_cri_mosaic_8bin_aq_interf 
     USE module_kpp_crimech_interf 
     USE module_kpp_gocartracm_interf 
     USE module_kpp_mozart_interf 
     USE module_kpp_mozart_mosaic_4bin_interf 
     USE module_kpp_mozart_mosaic_4bin_aq_interf 
     USE module_kpp_mozcart_interf 
     USE module_kpp_nmhc9_interf 
     USE module_kpp_racm_interf 
     USE module_kpp_racm_esrlsorg_interf 
     USE module_kpp_racm_esrlsorg_aqchem_interf 
     USE module_kpp_racm_mim_interf 
     USE module_kpp_racm_soa_vbs_interf 
     USE module_kpp_racm_soa_vbs_aqchem_interf 
     USE module_kpp_racmpm_interf 
     USE module_kpp_racmsorg_interf 
     USE module_kpp_racmsorg_aqchem_interf 
     USE module_kpp_radm2_interf 
     USE module_kpp_radm2sorg_interf 
     USE module_kpp_saprc99_interf 
     USE module_kpp_saprc99_mosaic_4bin_vbs2_interf 
     USE module_kpp_saprc99_mosaic_8bin_vbs2_aq_interf 
     USE module_kpp_t1_mozcart_interf 

       IMPLICIT NONE




    INTEGER,      INTENT(IN   ) ::    &
                      ids,ide, jds,jde, kds,kde,      & 
                      ims,ime, jms,jme, kms,kme,      & 
                      its,ite, jts,jte, kts,kte 



    INTEGER,      INTENT(IN   ) :: id

    REAL,      INTENT(IN   ) :: dtstepc 

    TYPE(grid_config_rec_type),  INTENT(IN   )    :: config_flags


    REAL, DIMENSION( ims:ime, kms:kme, jms:jme, num_chem ),            &
	        INTENT(INOUT ) ::                               chem 


    REAL, DIMENSION( ims:ime, kms:kme, jms:jme, num_moist ),            &
	        INTENT(IN ) ::                               moist 



     REAL,  DIMENSION( ims:ime , kms:kme , jms:jme ),              &
             INTENT(IN   ) ::                                      &          
                                                         p_phy,    &
                                                         t_phy,    &  
                                                         rho_phy        




    INTEGER, INTENT ( IN ) :: ldrog
  
    REAL,      INTENT(INOUT) ::                                     &
                      vdrog3(ims:ime,kms:kme-0,jms:jme,ldrog)


    INTEGER, INTENT ( IN ) :: ldrog_vbs
  
    REAL,      INTENT(INOUT) ::                                     &
                      vdrog3_vbs(ims:ime,kms:kme-0,jms:jme,ldrog_vbs)







      REAL, DIMENSION( ims:ime, kms:kme, jms:jme ),   & 
         INTENT(INOUT ) ::  & 
               addt, addx, addc, etep, oltp, & 
               olip, cslp, limp, hc5p, hc8p, & 
               tolp, xylp, apip, isop, hc3p, & 
               ethp, o3p, tco3, mo2, o1d, & 
               olnn, olnd, rpho, xo2, ketp, & 
               xno2, ol2p, oln, macp, hocoo, & 
               bzno2_o, bz_o, tbu_o




      REAL, DIMENSION( ims:ime, kms:kme, jms:jme ),   & 
         INTENT(INOUT ) ::  & 
               ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
               ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
               ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
               ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
               ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
               ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
               ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
               ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
               ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
               ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
               ph_fmcl 









  kpp_chem_select: SELECT CASE(config_flags%chem_opt)  

   CASE (cb05_sorg_aq_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cb05_sorg_aq_interface') 

        CALL cb05_sorg_aq_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (cb05_sorg_vbs_aq_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cb05_sorg_vbs_aq_interface') 

        CALL cb05_sorg_vbs_aq_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (cbm4_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cbm4_interface') 

        CALL cbm4_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (cbmz_bb_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cbmz_bb_interface') 

        CALL cbmz_bb_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (cbmz_mosaic_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cbmz_mosaic_interface') 

        CALL cbmz_mosaic_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (cri_mosaic_4bin_aq_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cri_mosaic_4bin_aq_interface') 

        CALL cri_mosaic_4bin_aq_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (cri_mosaic_8bin_aq_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling cri_mosaic_8bin_aq_interface') 

        CALL cri_mosaic_8bin_aq_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (crimech_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling crimech_interface') 

        CALL crimech_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (gocartracm_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling gocartracm_interface') 

        CALL gocartracm_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (mozart_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling mozart_interface') 

        CALL mozart_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (mozart_mosaic_4bin_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling mozart_mosaic_4bin_interface') 

        CALL mozart_mosaic_4bin_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (mozart_mosaic_4bin_aq_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling mozart_mosaic_4bin_aq_interface') 

        CALL mozart_mosaic_4bin_aq_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (mozcart_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling mozcart_interface') 

        CALL mozcart_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (nmhc9_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling nmhc9_interface') 

        CALL nmhc9_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racm_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racm_interface') 

        CALL racm_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racm_esrlsorg_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racm_esrlsorg_interface') 

        CALL racm_esrlsorg_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racm_esrlsorg_aqchem_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racm_esrlsorg_aqchem_interface') 

        CALL racm_esrlsorg_aqchem_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racm_mim_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racm_mim_interface') 

        CALL racm_mim_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racm_soa_vbs_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racm_soa_vbs_interface') 

        CALL racm_soa_vbs_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racm_soa_vbs_aqchem_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racm_soa_vbs_aqchem_interface') 

        CALL racm_soa_vbs_aqchem_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racmpm_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racmpm_interface') 

        CALL racmpm_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racmsorg_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racmsorg_interface') 

        CALL racmsorg_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (racmsorg_aqchem_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling racmsorg_aqchem_interface') 

        CALL racmsorg_aqchem_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (radm2_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling radm2_interface') 

        CALL radm2_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (radm2sorg_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling radm2sorg_interface') 

        CALL radm2sorg_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (saprc99_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling saprc99_interface') 

        CALL saprc99_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (saprc99_mosaic_4bin_vbs2_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling saprc99_mosaic_4bin_vbs2_interface') 

        CALL saprc99_mosaic_4bin_vbs2_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (saprc99_mosaic_8bin_vbs2_aq_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling saprc99_mosaic_8bin_vbs2_aq_interface') 

        CALL saprc99_mosaic_8bin_vbs2_aq_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )


   CASE (t1_mozcart_kpp) 

        CALL wrf_debug(15,'kpp_mechanism_driver: calling t1_mozcart_interface') 

        CALL t1_mozcart_interface(     &

    chem, id, dtstepc,config_flags, & 
    p_phy,t_phy,rho_phy,moist,     &
    vdrog3, ldrog, vdrog3_vbs, ldrog_vbs,            &

             addt, addx, addc, etep, oltp, & 
             olip, cslp, limp, hc5p, hc8p, & 
             tolp, xylp, apip, isop, hc3p, & 
             ethp, o3p, tco3, mo2, o1d, & 
             olnn, olnd, rpho, xo2, ketp, & 
             xno2, ol2p, oln, macp, hocoo, & 
             bzno2_o, bz_o, tbu_o,  & 
             ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, & 
             ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, & 
             ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, & 
             ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, & 
             ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, & 
             ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, & 
             ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, & 
             ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, & 
             ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, & 
             ph_mekooh, ph_tolooh, ph_terpooh, ph_cl2, ph_hocl, & 
             ph_fmcl,  & 
              ids,ide, jds,jde, kds,kde,         &
              ims,ime, jms,jme, kms,kme,         &
              its,ite, jts,jte, kts,kte         )



     CASE  DEFAULT

     END SELECT kpp_chem_select

 END SUBROUTINE kpp_mechanism_driver

